/**
 * Projeto: JavaLight
 * Tipo: Alimento
 * @author Mateus Dantas de Paula(mdp@cin.ufpe.br)
 */

package Alimento;

public class CadastroAlimentos {
  private RepositorioAlimentos alimentos; //Lista de alimentos

/**
* Construtor da classe CadastroAlimentos
*/
  public CadastroAlimentos(RepositorioAlimentos alimentosTemp) {
    alimentos = alimentosTemp;
  }

/**
* Mtodo para remover um alimento da lista
*
* @param nome: String com o nome do alimento
* return: um booleano mostrando se o alimento foi removido ou no
*
*/

  public boolean removerAlimento (String nome) {
     return alimentos.excluir(nome);
  }

/**
* Mtodo para mostrar todos os alimentos da lista
*
* return: uma funo que imprime na tela todos os alimentos
*
*/
  public boolean mostrarTudo () {
  return alimentos.mostrarTudo();
  }

/**
* Mtodo para criar um novo alimento na lista
*
* @param alimentoTemp: Objeto do tipo Alimento
*
*/
  public void criarAlimento (Alimento alimentoTemp) {
  alimentos.inserir(alimentoTemp);
  }

/**
* Mtodo para procurar um alimento na lista
*
* @param nome: String com o nome do alimento
* return: um objeto do tipo Alimento
*
*/
  public Alimento procurarAlimento (String nome) {
    return alimentos.procurar( nome );
  }

/**
* Mtodo para procurar um alimento na lista
*
* @param nome: String com o nome do alimento
* return: um booleano mostrando se o alimento foi encontrado ou no
*
*/
  public boolean existeAlimento (String nome) {
   return alimentos.existe(nome);
  }

/**
* Mtodo para procurar um alimento na lista
*
* @param nome: String com o nome do alimento
* return: um booleano mostrando se o alimento foi encontrado ou no
*
*/



/**
* Mtodo para retornar o nmero de alimento na lista
*
* return: um int com o nmero de alimentos
*
*/
  public int getNumeroAl () {
  return alimentos.getNumeroAl();
  }


}