/**
 * Projeto: JavaLight
 * Tipo: Alimento
 * @author Mateus Dantas de Paula(mdp@cin.ufpe.br)
 */


package Alimento;

public class RepositorioAlimentosLista implements RepositorioAlimentos{

  private int numeroAl; //nmero de alimentos
  private Alimento alimento; //alimento
  private RepositorioAlimentosLista next ; //prximo alimento
  private IteratorAlimentoConjunto iterator;
  /**
   * Construtor da classe RepositrioAlimentosLista
   *
   */
  public RepositorioAlimentosLista() {
  }


/**
* Mtodo para inserir um alimento na lista
*
* @param alimentoTemp: int com a frequncia do exerccio
*
*/
   public void inserir (Alimento alimentoTemp) {

         if ( alimento == null ) {
             numeroAl++;
             alimento = alimentoTemp;
             next = new RepositorioAlimentosLista();
         } else {
             next.inserir( alimentoTemp );
         }

   }


/**
* Mtodo para mostrar a lista de alimentos
*
* return: booleano mostrando se a lista existe ou no
*
*/
   public boolean mostrarTudo( ) {
       int i;
      boolean teste = false;
       if(alimento == null) teste =  true;

        for(i=0; i < numeroAl; i++)  {
             if(alimento != null) {
                System.out.print(alimento.getNome()+ " :  " + alimento.getPontos() + " pontos \n");

             if (next!=null)
              next.mostrarTudo();
             }


        }

       return teste;

     }


/**
* Mtodo para excluir um alimento da dieta
*
* @param alimentoTemp: int com a frequncia do exerccio
*
*/
   public boolean excluir( String nomeAlimentoTemp ) {
         boolean teste = false;
         Alimento alimentoTemp = null;
         alimentoTemp = procurar(nomeAlimentoTemp);

         if( this.alimento != null ) {
             if( this.alimento.equals( alimentoTemp ) ) {
                 this.alimento = this.next.alimento;
                 this.next = this.next.next;
             } else {
                 this.next.excluir( nomeAlimentoTemp );
             }
         }
         else {
         numeroAl --;
         teste =  true;
         }
        return teste;

   }


/**
* Mtodo para procurar um alimento
*
* @param nome: String com o nome do cliente
* return: Objeto do tipo Alimento
*
*/
   public Alimento procurar(String nome) {

     Alimento retorno = null;
        if( alimento != null ) {
            if( alimento.getNome().equals( nome ) ) {
                retorno = alimento;
            } else {
                retorno = next.procurar( nome );
            }
        }
        return retorno;

   }

/**
* Mtodo para procurar um alimento na lista
*
* @param nome: String com o nome do alimento
* return: um booleano mostrando se o alimento foi encontrado ou no
*
*/
  public boolean existe (String nome) {
    boolean teste = false;
    Alimento temp = null;
    temp = procurar(nome);
    if(temp != null) {
      teste = true;
    }
    else
      teste = false;
    return teste;
  }

/**
* Mtodo para setar o alimento do exercicio
*
* @param alimentoTemp: int com a frequncia do exerccio
*
*/
   public void setalimento (Alimento alimentoTemp) {
     alimento = alimentoTemp;
   }


/**
* Mtodo para retornar o nmero de alimentos
*
* return: int com a nmero de alimentos
*
*/
  public int getNumeroAl () {
    return numeroAl;
  }


  public IteratorAlimentoConjunto getIterator() {
    iterator = new IteratorAlimentoConjunto();
    iterator.add(this.alimento);
    if (this.next != null)
      this.getIteratorNext(this.next);
    return this.iterator;
  }


  private void getIteratorNext(RepositorioAlimentosLista alimentosTemp ) {
      this.iterator.add(alimentosTemp.alimento);
         if(alimentosTemp.next != null)
          getIteratorNext(alimentosTemp.next);
  }





/*  public boolean mostrarTudo( ) {
    iterator = this.getIterator();
    while(this.iterator.hasNext())
      System.out.print(this.iterator.next().getNome()+ "te");
    return true;
  }
*/


}
