/**
 * Projeto: JavaLight
 * Tipo: Alimento
 * @author Gustavo Santana(gals@cin.ufpe.br)
 */


package Cliente;


public class CadastroClientes {
  private RepositorioClientes clientes; //Lista de clientes

/**
 *
 * Construtor da Classe CadastroClientes
 *
 */
  public CadastroClientes(RepositorioClientes clientesTemp) {
    clientes = clientesTemp;
  }

/**
* Mtodo para remover um cliente da lista
*
* @param: um String contendo o nome do cliente
* return: um booleano verificando se houve a remoo ou no
*
*/
  public boolean removerCliente (String nome) {
    return clientes.excluir(nome);
    }

/**
* Mtodo para criar um cliente na lista
*
*
*/
  public void criarCliente (Cliente clienteTemp) {
    clientes.inserir(clienteTemp);
  }


/**
* Mtodo para mostrar todos os clientes da lista
*
*/
  public void mostrarTudo () {
    clientes.mostrarTudo();
  }

/**
* Mtodo para procurar um cliente na lista
*
*/
  public Cliente procurarCliente (String nome) {
    return clientes.procurar( nome );
  }

/**
* Mtodo para procurar um cliente na lista
*
*/
  public boolean existeCliente (String nome) {
    return clientes.existe(nome);
  }



/**
* Mtodo para retornar o nmero de clientes na lista
*
* return: inteiro contendo a quantidade de clientes
*/
  public int getNumero () {
    return clientes.getNumero();
  }

/**
* Mtodo para retornar a lista  de clientes na lista
*
* return: lista de clientes
*/

  public RepositorioClientes getClientes() {
   return this.clientes;
  }


}