/**
 * Projeto: JavaLight
 * Tipo: Domestica
 * @author Gustavo Santana(gals@cin.ufpe.br)
 */
package Domestica;

public class CadastroDomesticas {
    private RepositorioDomesticas domesticas; //Lista de Domestica

   /**
    *
    * Construtor da CadastroDomestica
    *
    */
    public CadastroDomesticas(RepositorioDomesticas domesticasTemp) {
        if ( domesticasTemp == null ) {
            throw new IllegalArgumentException("Argumento invlido.");
        }
        else {
            domesticas = domesticasTemp;
        }
    }

   /**
    * Mtodo para remover um Domestica da lista
    *
    * @param nome: um String contendo o nome do Domestica
    * return: um booleano verificando se houve a remoo ou no
    *
    */
    public boolean removerDomestica (String nome)
            throws DomesticaInexistenteException {
        boolean teste = false;
        Domestica temp = null;

        if ( nome == null ) {
            throw new IllegalArgumentException("Argumento invlido.");
        }
        else {
            temp = domesticas.procurar(nome);
            if( temp != null ) {
                domesticas.excluir(temp);
                teste = true;
            }
        }

        return teste;
    }

   /**
    * Mtodo para mostrar todos os elementos da lista
    *
    */
    public void mostrarTudo () {
        domesticas.mostrarTudo();
    }

   /**
    * Mtodo para criar um exerccio na lista
    *
    * @param domesticaTemp: um String contendo o nome do cliente
    * return: um booleano verificando se houve a remoo ou no
    *
    */
    public void criarDomestica (Domestica domesticaTemp)
            throws DomesticaExistenteException{
        if ( domesticaTemp == null ) {
            throw new IllegalArgumentException("Argumento invlido");
        }
        else {
            domesticas.inserir(domesticaTemp);
        }
    }

   /**
    * Mtodo para procurar um Domestica na lista
    *
    * @param domesticaTemp: um String contendo o nome do cliente
    * return: um booleano verificando se houve a remoo ou no
    *
    */
    public Domestica procurarDomestica (String nome) {
        Domestica retorno = null;

        if ( nome != null ) {
            retorno = domesticas.procurar( nome );
        }
        else {
            throw new IllegalArgumentException("Argumento invlido.");
        }

        return retorno;
    }


    public boolean existeDomestica (String nome) {
        boolean teste = false;

        if ( nome != null ) {
            throw new IllegalArgumentException("Argumento invlido");
        }
        else {
            if(domesticas.procurar(nome) != null) {
                teste = true;
            }
        }
        return teste;
    }

    /**
    * Mtodo para retornar o nmero na lista
    *
    * return: um inteiro contendo o nmero de domesticas
    *
    */
    public int getnumeroDo () {
        return domesticas.getnumeroDo();
    }
}