/**
 * Projeto: JavaLight
 * Tipo: Domestica
 * @author Gustavo Santana(gals@cin.ufpe.br)
 */
package Domestica;

//import javax.swing.JOptionPane;

public class RepositorioDomesticasLista implements RepositorioDomesticas {

    private int numeroDo;     //nmero
    private Domestica domestica;  //objeto do tipo Domestica
    private RepositorioDomesticasLista next;   // um objeto do tipo lista de domesticas
    private IteratorDomesticaConjunto iterator;

   /**
    * Construtor da classe RepositorioDaysArray
    */
    public RepositorioDomesticasLista() {
    }

   /**
    * Mtodo inserir
    *
    * @param domesticaTemp: Objeto do tipo Domestica
    *
    */
    public void inserir (Domestica domesticaTemp)
            throws DomesticaExistenteException{
        if ( !existe( domesticaTemp.getNome() ) ){
            if ( domestica == null ) {
                numeroDo++;
                domestica = domesticaTemp;
                next = new RepositorioDomesticasLista();
            } else {
                next.inserir( domesticaTemp );
            }
        } else {
            throw new DomesticaExistenteException();
        }
    }

    /**
    * Mtodo mostrarTudo
    *
    */
    public void mostrarTudo( ) {
        for( int i=0; i < numeroDo; i++)  {
            if(domestica != null) {
            //JOptionPane.showMessageDialog(null,domestica.getNome(),"Domesticas",
            //                           JOptionPane.INFORMATION_MESSAGE);
                System.out.print(domestica.getNome() + " com " + domestica.getBonus() + "\n");
                next.mostrarTudo();
            }
        }
    }


   /**
    * Mtodo excluir
    *
    * @param domesticaTemp: Objeto do tipo Domestica
    *
    */
    public void excluir( Domestica domesticaTemp )
            throws DomesticaInexistenteException {
        if( domesticaTemp != null) {
            if( this.domestica != null ) {
                if( this.domestica.equals( domesticaTemp ) ) {
                    this.domestica = this.next.domestica;
                    this.next = this.next.next;
                    numeroDo --;
                } else {
                    this.next.excluir( domesticaTemp );
                }
            } else {
                throw new DomesticaInexistenteException();
            }
      } else {
          throw new IllegalArgumentException("Argumento invlido.");
      }
    }

    /**
    * Mtodo procurar
    *
    * @param nome: String contendo o nome do Domestica
    *
    */
    public Domestica procurar( String nome ) {
        Domestica retorno = null;

        if( nome != null ) {
            if( domestica != null ) {
                if( domestica.getNome().equals( nome ) ) {
                    retorno = domestica;
                } else {
                    retorno = next.procurar( nome );
                }
            }
        } else {
            throw new IllegalArgumentException("Argumento invlido");
        }

        return retorno;
    }

   /**
    * Mtodo existe
    *
    * @param nome: String contendo o nome do Domestica
    *
    */
    public boolean existe(String nome) {
        boolean teste;

        if( procurar( nome ) != null) {
            teste = true;
        } else {
            teste = false;
        }

        return teste;
    }



   /**
    * Mtodo getnumeroEx
    *
    * return: inteiro contendo o nmero de exerccios na lista
    *
    */
    public int getnumeroDo () {
        return this.numeroDo;
    }


   /**
    * Mtodo para retornar o iterator
    *
    * @return: Iterator
    *
    */
    public IteratorDomesticaConjunto getIterator() {
        iterator = new IteratorDomesticaConjunto();
        iterator.add(this.domestica);

        if ( this.next != null ) {
            this.getIteratorNext(this.next);
        }

        return this.iterator;
    }

    /**
    * Mtodo para auxiliar o getIterator
    *
    * @param: RepositorioDomesticasLista
    *
    */
    private void getIteratorNext(RepositorioDomesticasLista domesticasTemp ) {
        this.iterator.add(domesticasTemp.domestica);

        if( domesticasTemp.next != null ) {
            getIteratorNext(domesticasTemp.next);
        }
    }
}