/**
 * Projeto: JavaLight
 * Tipo:Cliente
 * @author Gustavo Santana(gals@cin.ufpe.br)
 */


package Exercicio;
//import javax.swing.JOptionPane;


public class RepositorioExerciciosLista implements RepositorioExercicios{

  private int numeroEx;     //nmero de exerccios
  private Exercicio exercicio;  //objeto do tipo exerccio
  private RepositorioExerciciosLista next;   //prximo exerccio, um objeto do tipo lista de exerccios
  private IteratorExercicioConjunto iterator;
  /**
  * Construtor da classe RepositorioDaysArray
  */
  public RepositorioExerciciosLista() {
  }

  /**
  * Mtodo inserir
  *
  * @param exercicioTemp: Objeto do tipo Exercicio
  *
  */
  public void inserir (Exercicio exercicioTemp) throws ExercicioExistenteException {
         if (exercicioTemp != null) {
             if(!this.existe(exercicioTemp.getNome())) {
                  if ( exercicio == null ) {
                    numeroEx++;
                    exercicio = exercicioTemp;
                     next = new RepositorioExerciciosLista();
                   } else {
                        next.inserir( exercicioTemp );
                   }
              } else {
                throw new  ExercicioExistenteException();

              }


        } else {
            throw new IllegalArgumentException("Argumento puff invlido");
        }

  }

  /**
  * Mtodo mostrarTudo
  *
  *
  */
  public void mostrarTudo( ) {
       int i;
        for(i=0; i < numeroEx; i++)  {
             if(exercicio != null) {
              //JOptionPane.showMessageDialog(null,exercicio.getNome(),"Exercicios",
               //                           JOptionPane.INFORMATION_MESSAGE);
               System.out.print(exercicio.getNome() + " com " + exercicio.getBonus() + "\n");
               next.mostrarTudo();
             }

        }

  }


  /**
  * Mtodo excluir
  *
  * @param exercicioTemp: Objeto do tipo Exercicio
  *
  */
  public void excluir( Exercicio exercicioTemp ) {
         if( this.exercicio != null ) {
             if( this.exercicio.equals( exercicioTemp ) ) {
                 this.exercicio = this.next.exercicio;
                 this.next = this.next.next;
             } else {
                 this.next.excluir( exercicioTemp );
             }
         }
         else {
         numeroEx --;
         }

  }

  /**
  * Mtodo procurar
  *
  * @param nome: String contendo o nome do Exercicio
  *
  */
  public Exercicio procurar(String nome) {

         Exercicio retorno = null;
         if( nome != null ) {
             if( this.exercicio != null ) {
              if( exercicio.getNome().equals( nome ) ) {
                 retorno = exercicio;
              } else {
                retorno = next.procurar( nome );
             }
             }
          } else {
              throw new IllegalArgumentException("Argumento invlido");
          }

         return retorno;

  }

  /**
  * Mtodo existe
  *
  * @param nome: String contendo o nome do Exercicio
  *
  */

 public boolean existe(String nome) {
    boolean teste;
    Exercicio temp = null;
    temp = procurar(nome);
    if(temp != null) {
    teste = true;
    }
    else
     teste = false;
    return teste;
 }



  /**
  * Mtodo getnumeroEx
  *
  * return: inteiro contendo o nmero de exerccios na lista
  *
  */
  public int getnumeroEx () {
    return numeroEx;
  }


 /**
* Mtodo para retornar o iterator
*
* @return: Iterator
*
*/

  public IteratorExercicioConjunto getIterator() {
    iterator = new IteratorExercicioConjunto();
    iterator.add(this.exercicio);
    if (this.next != null)
      this.getIteratorNext(this.next);
    return this.iterator;
  }

/**
* Mtodo para auxiliar o getIterator
*
* @param: RepositorioExerciciosLista
*
*/

  private void getIteratorNext(RepositorioExerciciosLista exerciciosTemp ) {
      this.iterator.add(exerciciosTemp.exercicio);
         if(exerciciosTemp.next != null)
          getIteratorNext(exerciciosTemp.next);
  }

}