/**
 * Projeto: JavaLight
 * Tipo:Cliente
 * @author Gustavo Santana(gals@cin.ufpe.br)
 */
package Semana;

import Alimento.*;


public class RepositorioSemanaArray implements RepositorioSemanas {
    //private RepositorioDaysArray[] dieta;
    private Semana[] dieta;  //array de objeto do tipo Semana
    private IteratorSemanaConjunto iterator;

/*
    public void escolheralimento (Alimento novo, int dia, int semana) {
      dieta[semana].escolheralimento(novo,dia);
    }
*/

   /**
    * Construtor da classe RepositorioSemanaArray
    */
    public RepositorioSemanaArray() {
        dieta = new Semana[16];
    }

   /**
    * Mtodo removerAlimento
    *
    * @param nome: String contendo o nome do alimento a ser removido
    * @param i: inteiro contendo o ndice do alimento
    * @param semana: inteiro contendo o ndice da semana
    *
    */
    public boolean removerAlimento( String nome, int i,int semana )
            throws  AlimentoInexistenteException {
        boolean teste = false;

        if( nome == null) {
            throw new IllegalArgumentException("Argumento invlido.");
        } else {
            if(dieta[semana] == null )
                dieta[semana] = new Semana(120);

            if( dieta[semana].existeAlimentoNoDia(nome,i) ) {
                teste = dieta[semana].removerAlimento(nome,i);
            } else {
                throw new AlimentoInexistenteException();
            }
        }

        return teste;
    }

    /**
    * Mtodo existeAlimentoNaSemana
    *
    * @param nome: String contendo o nome do alimento a ser encontrado
    * @param i: inteiro contendo o ndice do alimento
    * @param semana: inteiro contendo o ndice da semana
    *
    * return: boolean contendo o valor verdade relativo  existncia do alimento
    */
    public boolean existeAlimentoNaSemana (String nome, int i,int semana) {
        boolean retorno = false;

        if ( nome == null ) {
            throw new IllegalArgumentException("Argumento invlido.");
        } else {
            if(dieta[semana] == null ) {
                dieta[semana] = new Semana(120);
            }
            retorno = dieta[semana].existeAlimentoNoDia(nome,i);
        }

        return retorno;
    }

   /**
    * Mtodo adicionarAlimento
    *
    * @param alimento: Objeto do tipo Alimento contendo o alimento a ser adicionado
    * @param i: inteiro contendo o ndice do alimento
    * @param semana: inteiro contendo o ndice da semana
    *
    */
    public void adicionarAlimento ( int semana, int dia , Alimento alimento) throws SemanaExistenteException,AlimentoExistenteException {
        if ( alimento == null ) {
            throw new IllegalArgumentException("Argumento invlido");
        } else {
            if(semana>=0 && semana <16) {
                if (dieta[semana].existeAlimentoNoDia(alimento.getNome(),dia) ) {
                  throw new SemanaExistenteException();
                } else {
                    if(dieta[semana] == null ) {
                      dieta[semana] = new Semana(120);
                    }
                    dieta[semana].adicionar(alimento,dia);
                  }
            } else {
              throw new IllegalArgumentException("Semana invlida");
            }
        }
    }

   /**
    * Mtodo getDiaDieta
    *
    * @param i: inteiro contendo o ndice do alimento
    * @param semana: inteiro contendo o ndice da semana
    *
    * return: objeto do tipo CadastroAlimentos contendo a dieta do dia
    */
    public CadastroAlimentos getDiaDieta(int semana,int dia){
        return dieta[semana].getDieta(dia);
    }

    /**
    * Mtodo getSemana
    *
    * @param semana: inteiro contendo o ndice da semana
    *
    * return: objeto do tipo Semana
    */
    public Semana getSemanaAtual (int semana) {
        if(dieta[semana] == null )
            dieta[semana] = new Semana(120);

        return dieta[semana];
    }

   /**
    * Mtodo para retornar o iterator
    *
    * @return: Iterator
    *
    */
    public IteratorSemanaConjunto getIterator() {
        int i;
        iterator = new IteratorSemanaConjunto();

        for( i= 0 ; i < 16; i++)
           iterator.add(this.dieta);

        return this.iterator;
    }
}