package Semana;
import Alimento.*;




public interface RepositorioSemanas {

  /**
  * Mtodo removerAlimento
  *
  * @param nome: String contendo o nome do alimento a ser removido
  * @param i: inteiro contendo o ndice do alimento
  * @param semana: inteiro contendo o ndice da semana
  *
  */


  public boolean removerAlimento( String nome, int i,int semana )
         throws  AlimentoInexistenteException;

  /**
  * Mtodo existeAlimentoNaSemana
  *
  * @param nome: String contendo o nome do alimento a ser encontrado
  * @param i: inteiro contendo o ndice do alimento
  * @param semana: inteiro contendo o ndice da semana
  *
  * return: boolean contendo o valor verdade relativo  existncia do alimento
  */
  public boolean existeAlimentoNaSemana (String nome, int i,int semana);

  /**
  * Mtodo existeAlimentoNaSemana
  *
  * @param alimento: Objeto do tipo Alimento contendo o alimento a ser adicionado
  * @param i: inteiro contendo o ndice do alimento
  * @param semana: inteiro contendo o ndice da semana
  *
  */
  public void adicionarAlimento ( int semana, int dia , Alimento alimento)throws SemanaExistenteException,AlimentoExistenteException;

  /**
  * Mtodo getDiaDieta
  *
  * @param i: inteiro contendo o ndice do alimento
  * @param semana: inteiro contendo o ndice da semana
  *
  * return: objeto do tipo CadastroAlimentos contendo a dieta do dia
  */
  public CadastroAlimentos getDiaDieta(int semana,int dia);

  /**
  * Mtodo getSemana
  *
  * @param semana: inteiro contendo o ndice da semana
  *
  * return: objeto do tipo Semana
  */
  public Semana getSemanaAtual (int semana);
 /**
* Mtodo para retornar o iterator
*
* @return: Iterator
*
*/

  public IteratorSemanaConjunto getIterator();
}