/**
 * Projeto: JavaLight
 * Tipo:Cliente
 * @author Gustavo Santana(gals@cin.ufpe.br)
 */
import Alimento.*;
 //import Alimento.CadastroAlimentos;
//import Alimento.RepositorioAlimentosLista;
//import Alimento.Alimento;
import Cliente.*;
//import Cliente.CadastroClientes;
//import Cliente.RepositorioClientesLista;
//import Cliente.Cliente;
//import Exercicio.CadastroExercicios;
import Domestica.*;
import Exercicio.*;
//import Exercicio.RepositorioExerciciosLista;
//import Exercicio.Exercicio;
//import Domestica.CadastroDomesticas;
//import Domestica.RepositorioDomesticasLista;
//import Domestica.Domestica;
//import Semana.CadastroSemanas;
//import Semana.Semana;
import Semana.*;
public class Sistema {

  private CadastroClientes cadastroClientes;  //Objeto do tipo CastroClientes, para cadastrar clientes
  private CadastroExercicios cadastroExercicios;  //Objeto do tipo CadastroExerccios, para cadastras exerccios
  private CadastroAlimentos cadastroAlimentos; //Objeto do tipo CastroAlimentos, para cadastrar alimentos
  private CadastroDomesticas cadastroDomesticas;
  private int dia,semana;  //inteiros de ndice para dia e semana
  boolean ok; //Booleanos de status de login
  private Cliente clienteLogado;
  /**
  * Construtor da classe Sistema, a fachada
  *
  */
  public Sistema() {
    cadastroExercicios = new CadastroExercicios(new RepositorioExerciciosLista());
    cadastroClientes = new CadastroClientes(new RepositorioClientesLista());
    cadastroAlimentos = new CadastroAlimentos(new RepositorioAlimentosLista());
    this.clienteLogado = null;
    }

  /**
  * Mtodo logar
  *
  * @param login: String contendo o login do cliente
  * @param dia: inteiro contendo o ndice do alimento
  * @param semana: inteiro contendo o ndice da semana
  *
  * return: Objeto do tipo Cliente
  */

  /**
    * Retorna o  cliente
    *
    * @return: Um Cliente contendo o peso do cliente
    *
    */
   public Cliente getCliente (){
      return this.clienteLogado;
   }

  public boolean logar (String login,int dia,int semana) {
    boolean teste = false;
    this.dia=dia;
    this.semana=semana;
    Cliente temp;
    temp = cadastroClientes.procurarCliente(login);
    if ( ((temp != null)&& (this.clienteLogado == null)) && ((dia >0) && (dia <=7)) && ((semana >0) && (semana <=16)) ) {
      this.clienteLogado = temp;
      temp.setLogado (true);
      teste = true;
    }
    else
      teste = false;
    return teste;
  }

 public boolean deslogar (Cliente login) {
    boolean teste = false;
    if ( this.clienteLogado != null ) {
      login.setLogado(false);
      this.clienteLogado = null;
      teste = true;
    }
    else
      teste = false;
   return teste;
  }


  /**
  * Mtodo novoCliente
  *
  * @param clienteTemp: Objeto do tipo cliente
  *
  */
  public void novoCliente (Cliente clienteTemp) {
    if (this.clienteLogado == null)
      cadastroClientes.criarCliente(clienteTemp);
  }
/**
  * Mtodo novoTipo
  *
  * @param tipoTemp: Objeto do tipo tipo
  *
  */
  public void novoDomestica (Domestica domesticaTemp) throws DomesticaExistenteException {
       cadastroDomesticas.criarDomestica(domesticaTemp);

    }


  /**
  * Mtodo novoExercicio
  *
  * @param exercicioTemp: Objeto do tipo Exercicio
  *
  */
  public void novoExercicio (Exercicio exercicioTemp) throws ExercicioExistenteException {
    cadastroExercicios.criarExercicio(exercicioTemp);
  }

  /**
  * Mtodo novoAlimento
  *
  * @param alimentoTemp: Objeto do tipo Alimento
  *
  */
  public void novoAlimento (Alimento alimentoTemp) throws AlimentoExistenteException {
    cadastroAlimentos.criarAlimento(alimentoTemp);
  }

  /**
  * Mtodo removerCliente
  *
  * @param login: String contendo login do cliente
  *
  * return: booleano com resultado da remoo
  */
  public boolean removerCliente (String login) {
    return cadastroClientes.removerCliente(login);
  }

  /**
  * Mtodo existeCliente
  *
  * @param login: String contendo login do cliente
  *
  * return: booleano com resultado da verificao da existncia
  */
  /*public boolean existeCliente (String login) {
    return cadastroClientes.existeCliente(login);
  }*/

  /**
  * Mtodo mostrarClientes
  *
  */
  public void mostrarClientes () {
    cadastroClientes.mostrarTudo();
  }

  /**
  * Mtodo mostrarExercicios
  *
  */
  public void mostrarExercicios () {
    cadastroExercicios.mostrarTudo();
  }

  /**
  * Mtodo mostrarAlimentos
  *
  */
  public boolean mostrarAlimentos () {
    return cadastroAlimentos.mostrarTudo();
  }

  /**
  * Mtodo mostrarClientes
  *
  * @param temp: Objeto do tipo Cliente
  *
  */
/*  public void mostrarSerieDe (Cliente temp) {
    if (temp.getLogado())
      temp.getSerie().mostrarTudo();
  }
*/
 /**
  * Mtodo mostrarClientes
  *
  * @param temp: Objeto do tipo Cliente
  *
  */
  public void mostrarSerie () {
    if (this.clienteLogado != null)
      this.clienteLogado.getSerie().mostrarTudo();
  }

  /**
  * Mtodo getSemana
  *
  * @param temp: objeto do tipo Cliente
  * @param semana: inteiro contendo o ndice da semana
  *
  * return: Objeto do tipo Semana
  */
  public Semana getSemana ( Cliente temp, int semana) {
    return temp.getDieta().getSemanas().getSemanaAtual(semana);
  }

  /**
  * Mtodo mostrarDieta
  *
  * @param temp: objeto do tipo Cliente
  * @param semana: inteiro contendo o ndice da semana
  * @param dia: inteiro contendo o ndice do dia
  *
  */
  public void mostrarDieta (int dia ,int semana) {
    if (this.clienteLogado.getLogado() && (this.clienteLogado.getDieta().getSemanas().getSemanaAtual(semana).getDieta(dia).getNumeroAl()>0))
      this.clienteLogado.getDieta().mostrarDieta(dia,semana);
  }

  /**
  * Mtodo escolherExercicio
  *
  * @param nome: String contendo o nome do exercicio
  *
  *
  */
  public void escolherExercicio (String nome, int noHoras) throws ExercicioExistenteException{
    Exercicio temp;
    if(this.clienteLogado != null) {
      temp = cadastroExercicios.procurarExercicio(nome);
      if (temp != null && (!this.clienteLogado.getSerie().existeExercicio(nome))) {
        temp.setHoras(noHoras);
        this.clienteLogado.getSerie().criarExercicio(temp);
        this.clienteLogado.getDieta().getSemanas().getSemanaAtual(this.semana).bonus(temp.desconto());

      }
    }
  }
  /**
  * Mtodo escolherTipoAtividade
  *
  * @param nome: String contendo o nome do tipo
  *
  *
  */
  public void escolherTipo (String nome) throws DomesticaExistenteException {
    Domestica temp;
    if(this.clienteLogado != null) {
      temp = cadastroDomesticas.procurarDomestica(nome);
      if (temp != null && (!this.clienteLogado.getTiposAtividade().existeDomestica(nome))) {
        this.clienteLogado.getTiposAtividade().criarDomestica(temp);
        this.clienteLogado.getDieta().getSemanas().getSemanaAtual(this.semana).bonus(temp.desconto());

      }
    }
  }


  /**
  * Mtodo escolherAlimento
  *
  * @param nome: String contendo o nome do alimento
  *
  *
  */
  public void escolherAlimento (String nome) throws SemanaExistenteException, AlimentoExistenteException  {
     Alimento temp;
     if(this.clienteLogado != null) {
       temp = cadastroAlimentos.procurarAlimento(nome);
     if (temp != null)
       this.clienteLogado.getDieta().adicionar(temp,this.semana,this.dia);
     }
  }

  /**
  * Mtodo getSemanaAtual
  *
  * return: inteiro contendo a semana atual
  *
  */
  public int getSemanaAtual() {
    int resultado;
    if (this.clienteLogado != null)
      resultado = this.semana;
    else
      resultado = 0;
   return resultado;
  }

  /**
  * Mtodo getDia
  *
  * return: inteiro contendo o dia atual
  *
  */
  public int getDia() {
    if (this.clienteLogado != null)
      return dia;
    else
      return 0;
  }

  /**
  * Mtodo getLogado
  *
  * return: booleano contendo o status do login
  *
  */
  public Cliente getLogado () {
    return this.clienteLogado;
  }
  public CadastroExercicios getCadastroExercicios(){
    return this.cadastroExercicios;
  }

    public CadastroAlimentos getCadastroAlimentos(){
    return this.cadastroAlimentos;
  }


}